REM Sub Findvar v1.2a PD 2004.
REM $INCLUDE: 'qbx.bi'
DIM Variables(1024) AS STRING
DIM InregsX AS RegTypeX
DIM OutregsX AS RegTypeX
COLOR 15, 0
PRINT "Variable finder v1.0a:"
' read command line from PSP
CommandLine$ = ""
InregsX.AX = &H6200
CALL InterruptX(&H21, InregsX, OutregsX)
PSPsegment = OutregsX.BX
PSPoffset = 128
DEF SEG = PSPsegment
FOR Count = 1 TO 127
   Command.Char = PEEK(PSPoffset + Count)
   SELECT CASE Command.Char
   CASE 0, 10, 13
      EXIT FOR
   CASE ELSE
      CommandLine$ = CommandLine$ + CHR$(Command.Char)
   END SELECT
NEXT
DEF SEG
CommandLine$ = LTRIM$(CommandLine$)
IF LEN(CommandLine$) THEN
   Var = INSTR(UCASE$(CommandLine$), "/X")
   IF Var THEN
      CommandLine$ = LEFT$(CommandLine$, Var - 1) + MID$(CommandLine$, Var + 2)
      OutputFile = -1
   END IF
END IF
IF CommandLine$ = "/?" OR CommandLine$ = "-?" THEN
   COLOR 14, 0
   PRINT "Finds variables in Basic source files;"
   PRINT "Specify variable to find on command line."
   COLOR 7, 0
   PRINT "Exiting to system:"
   END
END IF
IF CommandLine$ = "" THEN
   COLOR 15, 0
   PRINT "Enter variable name? ";
   LINE INPUT CommandLine$
END IF
PRINT "Case sensitive(y/n)? ";
LOCATE , , 1
DO
   Var$ = INKEY$
   IF LEN(Var$) THEN
      SELECT CASE LCASE$(Var$)
      CASE "y"
         PRINT "y"
         Sensitive = -1
         EXIT DO
      CASE "n"
         PRINT "n"
         Sensitive = 0
         EXIT DO
      END SELECT
   END IF
LOOP
COLOR 15, 0
PRINT "Finding: "; CHR$(34);
COLOR 14, 0
PRINT CommandLine$;
COLOR 15, 0
PRINT CHR$(34); " ";
VarF! = TIMER
Variable1 = 0
IF Sensitive = 0 THEN
   CommandLine$ = LCASE$(CommandLine$)
END IF
FOR File.Types = 1 TO 3
   SELECT CASE File.Types
   CASE 1
      FileSpec$ = "*.bi"
   CASE 2
      FileSpec$ = "*.inc"
   CASE 3
      FileSpec$ = "*.bas"
   END SELECT
   Filename$ = DIR$(FileSpec$)
   WHILE LEN(Filename$)
      CLOSE
      OPEN Filename$ FOR INPUT AS #1
      Variable3 = Variable3 + 1
      GOSUB Dot.Display
      ' go through file searching for variable
      DO WHILE NOT EOF(1)
         LINE INPUT #1, InputLine$
         InputLine$ = LTRIM$(InputLine$)
         InputLine$ = RTRIM$(InputLine$)
         IF Sensitive = 0 THEN
            InputLine$ = LCASE$(InputLine$)
         END IF
         IF LEN(InputLine$) > 0 THEN
            IF INSTR(InputLine$, CommandLine$) > 0 THEN
               Variable1 = Variable1 + 1
               Variable2 = Variable2 + 1
               Variables(Variable1) = Filename$
               ' go through remaining file counting variables
               DO WHILE NOT EOF(1)
                  LINE INPUT #1, InputLine$
                  InputLine$ = LTRIM$(InputLine$)
                  InputLine$ = RTRIM$(InputLine$)
                  IF Sensitive = 0 THEN
                     InputLine$ = LCASE$(InputLine$)
                  END IF
                  IF LEN(InputLine$) > 0 THEN
                     IF INSTR(InputLine$, CommandLine$) > 0 THEN
                        Variable2 = Variable2 + 1
                     END IF
                  END IF
               LOOP
            END IF
         END IF
      LOOP
      Filename$ = DIR$
   WEND
NEXT
PRINT
IF Variable1 > 1 THEN
   FOR Sort1 = 1 TO Variable1
      FOR Sort2 = Sort1 + 1 TO Variable1
         IF Variables(Sort1) > Variables(Sort2) THEN
            SWAP Variables(Sort1), Variables(Sort2)
         END IF
      NEXT
   NEXT
END IF
COLOR 15, 0
PRINT "Subroutines counted:"; Variable3
IF Variable2 = 1 THEN
   Var$ = " 1 variable "
ELSE
   Var$ = STR$(Variable2) + " variables "
END IF
SELECT CASE Variable1
CASE 0
   PRINT "No variables found in any subroutines."
CASE 1
   PRINT "Total of" + Var$ + "found in 1 subroutine."
CASE ELSE
   PRINT "Total of" + Var$ + "found in" + STR$(Variable1) + " subroutines."
END SELECT
Page = 2
COLOR 14, 0
IF Variable1 > 0 THEN
   IF OutputFile THEN
      CLOSE
      OPEN "finddata.dat" FOR OUTPUT AS #1
      PRINT #1, "Results for: " + CommandLine$
   END IF
   FOR Var = 1 TO Variable1
      Filename$ = Variables(Var)
      Filename$ = Filename$ + SPACE$(15 - LEN(Filename$))
      IF OutputFile THEN
         PRINT #1, Filename$;
      ELSE
         PRINT Filename$;
      END IF
      Line1 = Line1 + 1
      IF Line1 = 5 THEN
         IF OutputFile THEN
            PRINT #1, ""
         ELSE
            PRINT
            Page = Page + 1
            IF Page = 23 THEN
               Page = 0
               COLOR 15, 0
               PRINT "More:";
               WHILE INKEY$ = ""
               WEND
               PRINT
               COLOR 14, 0
            END IF
         END IF
         Line1 = 0
      END IF
   NEXT
END IF
IF OutputFile THEN
   PRINT #1, ""
ELSE
   PRINT
END IF
IF OutputFile THEN
   PRINT "Data written to Finddata.dat"
END IF
COLOR 7, 0
PRINT "Exiting to system:"
END

Dot.Display:
 VarG! = TIMER - VarE!
 IF VarG! < 0! THEN
    VarG! = Elapsed.Time! + 86400!
 END IF
 IF VarG! >= 1! THEN
    VarE! = TIMER
    IF VarD = 0 THEN
       VarC = VarC + 1
       PRINT ".";
       IF VarC = 5 THEN
          VarD = -1
          VarC = 0
       END IF
    ELSE
       VarC = VarC + 1
       LOCATE CSRLIN, POS(0) - 1, 0
       PRINT " ";
       LOCATE CSRLIN, POS(0) - 1, 1
       IF VarC = 5 THEN
          VarD = 0
          VarC = 0
       END IF
    END IF
 END IF
 RETURN

